'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InputBaseComponent = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _input = require('./input');

var _input2 = _interopRequireDefault(_input);

var _textarea = require('./textarea');

var _textarea2 = _interopRequireDefault(_textarea);

var _dropdown = require('./dropdown');

var _dropdown2 = _interopRequireDefault(_dropdown);

var _submitButton = require('./submit-button');

var _submitButton2 = _interopRequireDefault(_submitButton);

var _resetButton = require('./reset-button');

var _resetButton2 = _interopRequireDefault(_resetButton);

var _wrapper = require('./wrapper');

var _wrapper2 = _interopRequireDefault(_wrapper);

var _customInput = require('./custom-input');

var _customInput2 = _interopRequireDefault(_customInput);

var _customResetButton = require('./custom-reset-button');

var _customResetButton2 = _interopRequireDefault(_customResetButton);

var _customSubmitButton = require('./custom-submit-button');

var _customSubmitButton2 = _interopRequireDefault(_customSubmitButton);

var _inputBaseComponent = require('./inputBaseComponent');

var _inputBaseComponent2 = _interopRequireDefault(_inputBaseComponent);

var _form = require('./form');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Form = function (_Component) {
  _inherits(Form, _Component);

  function Form(props) {
    _classCallCheck(this, Form);

    var _this = _possibleConstructorReturn(this, (Form.__proto__ || Object.getPrototypeOf(Form)).call(this, props));

    var inputs = {};

    var getInput = function getInput(child) {
      var displayName = child.props ? child.type.displayName : '';

      switch (displayName) {
        case 'Wrapper':
          if (child.props.children) {
            if (child.props.children.length) {
              for (var x in child.props.children) {
                getInput(child.props.children[x]);
              }
            } else {
              getInput(child.props.children);
            }
          }
          break;
        case 'TextArea':
        case 'Input':
        case 'DropdownWrapper':
          inputs[child.props.name] = (0, _form.getInitialState)(child.props);break;
        case 'CustomInput':
          var customInput = child.props.children;
          inputs[customInput.props.name] = (0, _form.getInitialState)(customInput.props);
          break;
      }
    };

    var formElements = _this.props.children;
    for (var x in formElements) {
      if (_this.props.children.length) {
        getInput(_this.props.children[x]);
      } else {
        getInput(_this.props.children);
      }
    }
    _this.state = { forceDirty: false, inputs: inputs };
    return _this;
  }

  _createClass(Form, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(_ref) {
      var resetForm = _ref.resetForm,
          disableInputs = _ref.disableInputs,
          clearValuesOnReset = _ref.clearValuesOnReset,
          serverErrors = _ref.serverErrors;

      if (this.props.resetForm != resetForm && resetForm) {
        this.resetForm({ clearValues: clearValuesOnReset });
        this.props.formWasReset();
      }

      if (this.props.disableInputs != disableInputs) {
        this.setInputsValues({ disabled: disableInputs });
      }

      if (this.props.serverErrors != serverErrors && Object.keys(serverErrors).length) {
        this.setBackendErrors(serverErrors);
      }
    }
  }, {
    key: 'setBackendErrors',
    value: function setBackendErrors() {
      var errors = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      this.setState(_extends({}, (0, _form.getStateOnBackendErrors)(_extends({}, this.state), errors)));
    }
  }, {
    key: 'resetForm',
    value: function resetForm(_ref2) {
      var clearValues = _ref2.clearValues;

      this.setState(_extends({}, (0, _form.getStateOnResetForm)(_extends({}, this.state), clearValues)));
    }
  }, {
    key: 'getResetButtonProps',
    value: function getResetButtonProps(props) {
      var _this2 = this;

      return {
        disabled: this.props.disableInputs,
        onClick: function onClick(event) {
          event.preventDefault();
          _this2.resetForm({ clearValues: props.clearValues });
          // proceed to call the onReset prop from the Form.
          if (_this2.props.onReset) {
            _this2.props.onReset();
          }
        }
      };
    }
  }, {
    key: 'getSubmitButtonProps',
    value: function getSubmitButtonProps(props) {
      var _this3 = this;

      var amountOfInvalidFields = Object.keys(_extends({}, this.state.inputs)).filter(function (key) {
        return !_this3.state.inputs[key].valid;
      }).length;
      return {
        disabled: this.props.disableInputs || (props.disabledUntilFormIsValidated ? amountOfInvalidFields > 0 : false),
        onClick: function onClick(event) {
          event.preventDefault();
          _this3.submitForm();
        }
      };
    }
  }, {
    key: 'submitForm',
    value: function submitForm() {
      var _this4 = this;

      var amountOfInvalidFields = Object.keys(_extends({}, this.state.inputs)).filter(function (key) {
        return !_this4.state.inputs[key].valid;
      }).length;

      var inputs = _extends({}, this.state.inputs);
      //check if all the inputs are valid
      if (!amountOfInvalidFields) {
        // proceed to call the onSubmit prop from the Form.
        this.props.onSubmit(_extends({}, (0, _form.getInputsValues)(inputs)));
      } else {
        this.setInputsValues({ dirty: true });
        this.setState({ forceDirty: true });
      }
    }
  }, {
    key: 'setInputsValues',
    value: function setInputsValues() {
      var newValues = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var input = arguments[1];

      this.setState(_extends({}, (0, _form.getStateWithNewInputValues)(_extends({}, this.state), newValues, input)));
    }
  }, {
    key: 'getInputsCommonProps',
    value: function getInputsCommonProps(props) {
      var _this5 = this;

      var name = props.name,
          _validate = props.validate,
          _onChange = props.onChange,
          _onBlur = props.onBlur;

      var input = name;
      var _state = this.state,
          inputs = _state.inputs,
          forceDirty = _state.forceDirty;
      var _inputs$input = inputs[input],
          value = _inputs$input.value,
          valid = _inputs$input.valid,
          dirty = _inputs$input.dirty,
          errorMessage = _inputs$input.errorMessage,
          resetValue = _inputs$input.resetValue,
          disabled = _inputs$input.disabled;

      return {
        value: value, valid: valid, dirty: dirty, errorMessage: errorMessage, forceDirty: forceDirty, resetValue: resetValue, disabled: disabled,
        onChange: function onChange(value) {
          _this5.setInputsValues({ value: value }, input);
          if (_onChange) {
            _onChange(value);
          }
        },
        onBlur: function onBlur(value) {
          _this5.setInputsValues({ value: value }, input);
          if (_onBlur) {
            _onBlur(value);
          }
        },
        validate: function validate(value) {
          var extra = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

          if (_validate) {
            var validateObj = _validate(value, extra);
            _this5.setInputsValues({
              valid: validateObj.valid,
              errorMessage: validateObj.errorMessage,
              dirty: true
            }, input);
          } else {
            _this5.setInputsValues({
              valid: true,
              errorMessage: '',
              dirty: true
            }, input);
          }
        },
        valueWasResetted: function valueWasResetted() {
          _this5.setInputsValues({ resetValue: false }, input);
        }
      };
    }
  }, {
    key: 'getChildrenComponents',
    value: function getChildrenComponents(children) {
      var _this6 = this;

      return _react2.default.Children.map(children, function (child) {
        var component = child;
        var displayName = child.props ? child.type.displayName : '';
        switch (displayName) {
          case 'Wrapper':
            component = _react2.default.createElement(
              _wrapper2.default,
              child.props,
              _this6.getChildrenComponents(child.props.children)
            );
            break;
          case 'SubmitButton':
            component = _react2.default.cloneElement(child, _this6.getSubmitButtonProps(child.props));
            break;
          case 'ResetButton':
            component = _react2.default.cloneElement(child, _this6.getResetButtonProps(child.props));
            break;
          case 'TextArea':
          case 'Input':
          case 'DropdownWrapper':
            component = _react2.default.cloneElement(child, _this6.getInputsCommonProps(child.props));
            break;
          case 'CustomInput':
            var customInput = child.props.children;
            component = _react2.default.cloneElement(customInput, _this6.getInputsCommonProps(customInput.props));
            break;
          case 'CustomSubmitButton':
            var customSubmitButton = child.props.children.props ? child.props.children : _react2.default.createElement(
              'span',
              null,
              child.props.children
            );
            component = _react2.default.cloneElement(customSubmitButton, _this6.getSubmitButtonProps(child.props));
            break;
          case 'CustomResetButton':
            var customResetButton = child.props.children.props ? child.props.children : _react2.default.createElement(
              'span',
              null,
              child.props.children
            );
            component = _react2.default.cloneElement(customResetButton, _this6.getResetButtonProps(child.props));
            break;
        }
        return component;
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this7 = this;

      return _react2.default.createElement(
        'form',
        {
          action: '/',
          className: this.props.className,
          onSubmit: function onSubmit(evt) {
            evt.preventDefault();
            _this7.submitForm();
          }
        },
        _react2.default.createElement('input', {
          type: 'image',
          className: 'react-awesome-form-validator-image',
          style: { width: '0px', display: 'none' }
        }),
        this.getChildrenComponents(this.props.children)
      );
    }
  }]);

  return Form;
}(_react.Component);

Form.propTypes = {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  resetForm: _propTypes2.default.bool,
  clearValuesOnReset: _propTypes2.default.bool,
  formWasReset: _propTypes2.default.func,
  onSubmit: _propTypes2.default.func.isRequired,
  onReset: _propTypes2.default.func,
  disableInputs: _propTypes2.default.bool,
  serverErrors: _propTypes2.default.shape({})
};

Form.CustomInput = _customInput2.default;
Form.CustomInput.displayName = 'CustomInput';

Form.Input = _input2.default;
Form.Input.displayName = 'Input';

Form.TextArea = _textarea2.default;
Form.TextArea.displayName = 'TextArea';

Form.Dropdown = _dropdown2.default;
Form.Dropdown.displayName = 'DropdownWrapper';

Form.SubmitButton = _submitButton2.default;
Form.SubmitButton.displayName = 'SubmitButton';

Form.ResetButton = _resetButton2.default;
Form.ResetButton.displayName = 'ResetButton';

Form.CustomSubmitButton = _customSubmitButton2.default;
Form.CustomSubmitButton.displayName = 'CustomSubmitButton';

Form.CustomResetButton = _customResetButton2.default;
Form.CustomResetButton.displayName = 'CustomResetButton';

Form.Wrapper = _wrapper2.default;
Form.Wrapper.displayName = 'Wrapper';

exports.InputBaseComponent = _inputBaseComponent2.default;
var _default = Form;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(Form, 'Form', 'src/form/index.jsx');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/form/index.jsx');
}();

;
//# sourceMappingURL=index.js.map