'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var InputBaseComponent = function (_Component) {
  _inherits(InputBaseComponent, _Component);

  function InputBaseComponent(props) {
    _classCallCheck(this, InputBaseComponent);

    return _possibleConstructorReturn(this, (InputBaseComponent.__proto__ || Object.getPrototypeOf(InputBaseComponent)).call(this, props));
  }

  _createClass(InputBaseComponent, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(_ref) {
      var forceDirty = _ref.forceDirty,
          resetValue = _ref.resetValue,
          valueWasResetted = _ref.valueWasResetted,
          serverValue = _ref.serverValue;

      if (!this.isDirty() && this.props.forceDirty != forceDirty && forceDirty) {
        var value = this.refs[this.props.name].value;
        this.props.validate(value);
      }

      if (this.props.serverValue !== serverValue) {
        this.props.onChange(serverValue);
        this.props.validate(serverValue);
      }

      if (this.props.resetValue != resetValue && resetValue) {
        // do something
        valueWasResetted();
      }
    }
  }, {
    key: 'inputIsValid',
    value: function inputIsValid() {
      return this.props.valid || this.isPristine();
    }
  }, {
    key: 'isDirty',
    value: function isDirty() {
      return this.props.dirty;
    }
  }, {
    key: 'isPristine',
    value: function isPristine() {
      return !this.props.dirty;
    }
  }, {
    key: 'renderLabel',
    value: function renderLabel() {
      if (this.props.label) {
        return _react2.default.createElement(
          'label',
          null,
          this.props.label
        );
      }
      if (this.props.customLabel) {
        return _react2.default.createElement(this.props.customLabel, null);
      }
    }
  }, {
    key: 'renderError',
    value: function renderError() {
      if (this.props.errorMessage && !this.isPristine() && !this.props.valid) {
        return _react2.default.createElement(
          'p',
          null,
          _react2.default.createElement(
            'span',
            null,
            this.props.errorMessage
          )
        );
      }
    }
  }]);

  return InputBaseComponent;
}(_react.Component);

InputBaseComponent.propTypes = {
  forceDirty: _propTypes2.default.bool.isRequired,
  name: _propTypes2.default.string.isRequired,
  validate: _propTypes2.default.func,
  label: _propTypes2.default.string,
  customLabel: _propTypes2.default.node,
  valid: _propTypes2.default.bool,
  dirty: _propTypes2.default.bool,
  errorMessage: _propTypes2.default.string,
  resetValue: _propTypes2.default.bool,
  serverValue: _propTypes2.default.string,
  onChange: _propTypes2.default.func
};

var _default = InputBaseComponent;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(InputBaseComponent, 'InputBaseComponent', 'src/form/inputBaseComponent.jsx');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/form/inputBaseComponent.jsx');
}();

;
//# sourceMappingURL=inputBaseComponent.js.map