'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _inputBaseComponent = require('../inputBaseComponent');

var _inputBaseComponent2 = _interopRequireDefault(_inputBaseComponent);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextArea = function (_InputBaseComponent) {
  _inherits(TextArea, _InputBaseComponent);

  function TextArea(props) {
    _classCallCheck(this, TextArea);

    return _possibleConstructorReturn(this, (TextArea.__proto__ || Object.getPrototypeOf(TextArea)).call(this, props));
  }

  _createClass(TextArea, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          _props$fieldClassName = _props.fieldClassName,
          fieldClassName = _props$fieldClassName === undefined ? '' : _props$fieldClassName,
          _props$type = _props.type,
          type = _props$type === undefined ? 'text' : _props$type,
          _props$placeHolder = _props.placeHolder,
          placeHolder = _props$placeHolder === undefined ? '' : _props$placeHolder,
          name = _props.name,
          _props$className = _props.className,
          className = _props$className === undefined ? '' : _props$className,
          _props$invalidClassNa = _props.invalidClassName,
          invalidClassName = _props$invalidClassNa === undefined ? '' : _props$invalidClassNa,
          value = _props.value,
          _props$startValidatin = _props.startValidatingWhenIsPristine,
          startValidatingWhenIsPristine = _props$startValidatin === undefined ? false : _props$startValidatin,
          _props$rows = _props.rows,
          rows = _props$rows === undefined ? '4' : _props$rows,
          _props$cols = _props.cols,
          cols = _props$cols === undefined ? '50' : _props$cols,
          disabled = _props.disabled;

      return _react2.default.createElement(
        'div',
        { className: fieldClassName },
        this.renderLabel(),
        _react2.default.createElement('textarea', {
          type: type,
          name: name,
          value: value,
          rows: rows,
          cols: cols,
          autoComplete: 'off',
          placeholder: placeHolder,
          disabled: disabled,
          className: (0, _classnames2.default)(!this.inputIsValid() ? invalidClassName : '', className),
          ref: name,
          onChange: function onChange(evt) {
            var value = evt.target.value;
            _this2.props.onChange(value);
            if (startValidatingWhenIsPristine) {
              _this2.props.validate(value);
            } else {
              if (!_this2.isPristine()) {
                _this2.props.validate(value);
              }
            }
          },
          onBlur: function onBlur(evt) {
            var value = evt.target.value;
            _this2.props.onBlur(value);
            _this2.props.validate(value);
          }
        }),
        this.renderError()
      );
    }
  }]);

  return TextArea;
}(_inputBaseComponent2.default);

TextArea.propTypes = {
  fieldClassName: _propTypes2.default.string,
  placeHolder: _propTypes2.default.string,
  label: _propTypes2.default.string,
  name: _propTypes2.default.string.isRequired,
  rows: _propTypes2.default.string,
  cols: _propTypes2.default.string,
  value: _propTypes2.default.string,
  className: _propTypes2.default.string,
  invalidClassName: _propTypes2.default.string,
  validate: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  onBlur: _propTypes2.default.func,
  startValidatingWhenIsPristine: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool
};

var _default = TextArea;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(TextArea, 'TextArea', 'src/form/textarea/index.jsx');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/form/textarea/index.jsx');
}();

;
//# sourceMappingURL=index.js.map